from math import inf
from pile import *
from file import *


#Compléter les quelques méthodes incomplétes ci-dessous :

class GrapheNO:
    
    def __init__(self,dico_voisins):
        for liste in dico_voisins.values():
            liste.sort()
        self.dico_voisins = dico_voisins # Voir les exemples ligne 130.
        
    def get_dico_voisins(self):
        return self.dico_voisins
    
    def liste_sommet(self):
        # renvoie la liste des sommets de self
        pass # A COMPLETER
    
    def ordre(self):
        #Renvoie le nombre_de_sommets de self
        pass # A COMPLETER
        
    def ajouter_sommet(self,nouveau_sommet):
        self.dico_voisins[nouveau_sommet]=[]
        
    def creer_arete_entre(self,sommet1,sommet2):
        if sommet1 not in self.get_dico_voisins():
            self.ajouter_sommet(sommet1)
        if sommet2 not in self.get_dico_voisins():
            self.ajouter_sommet(sommet2)
        if sommet2 not in self.dico_voisins[sommet1]:
            self.dico_voisins[sommet1].append(sommet2)
            self.dico_voisins[sommet1].sort()
        if sommet1 not in self.dico_voisins[sommet2]:
            self.dico_voisins[sommet2].append(sommet1)
            self.dico_voisins[sommet2].sort()
            

    
    def liste_des_voisins(self,sommet):
        # renvoie la liste des voisins d'un sommet de self
        # et None si le sommet n'a pas de voisin
        pass # A COMPLETER
        
    def degre(self,sommet):
        # renvoie le degré d'un sommet de self
        pass # A COMPLETER
        
    def sont_adjacents(self,sommet1,sommet2):
        if sommet1 in self.dico_voisins and sommet2 in self.dico_voisins:
            return sommet1 in self.liste_des_voisins(sommet2)
    
    def parcours_en_largeur_a_partir_de(self,sommet_de_depart):
        a_traiter = File()
        deja_visite = []
        a_traiter.enfile(sommet_de_depart)
        while not a_traiter.est_vide():
            sommet_actuel = a_traiter.defile()
            if sommet_actuel not in deja_visite :
                deja_visite.append(sommet_actuel)
            for voisin in self.liste_des_voisins(sommet_actuel):
                if voisin not in deja_visite and not a_traiter.contient(voisin):
                    a_traiter.enfile(voisin)
        return deja_visite
    
    def parcours_en_profondeur_a_partir_de(self,sommet_de_depart):
        a_traiter = Pile()
        deja_visite = []
        a_traiter.empile(sommet_de_depart)
        while not a_traiter.est_vide():
            sommet_actuel = a_traiter.depile()
            if sommet_actuel not in deja_visite :
                deja_visite.append(sommet_actuel)
            for voisin in self.liste_des_voisins(sommet_actuel):
                if voisin not in deja_visite and not a_traiter.contient(voisin):
                    a_traiter.empile(voisin)
        return deja_visite
    
    def plus_court_chemin_entre(self,sommet1,sommet2):
        a_traiter = File()
        pere_de = {}
        a_traiter.enfile(sommet1)
        pere_de[sommet1] = None
        while not a_traiter.est_vide() and sommet2 not in pere_de:
            sommet_actuel = a_traiter.defile()
            
            for voisin in self.liste_des_voisins(sommet_actuel):
                
                if voisin not in pere_de.keys() and not a_traiter.contient(voisin):
                    a_traiter.enfile(voisin)
                    pere_de[voisin] = sommet_actuel
        if sommet2 in pere_de.keys():
            chemin=[sommet2]
            sommet = sommet2
            while sommet != sommet1:
                sommet = pere_de[sommet]
                chemin = [sommet] + chemin
            return chemin
        else:
            return []
    
    def est_connexe(self):
        ordre = self.ordre()
        for sommet in self.dico_voisins.keys():
            if len(self.parcours_en_largeur_a_partir_de(sommet)) != ordre:
                return False
        return True
    
    def distance_entre(self,sommet1,sommet2):
        chemin = self.plus_court_chemin_entre(sommet1,sommet2)
        if chemin == []:
            return inf
        else:
            return len(chemin)-1
    
    def matrice_d_adjacence(self):
        sommet = sorted(self.dico_voisins.keys())
        ordre = len(sommet)
        matrice = [[0 for i in range(ordre)] for j in range(ordre)]
        for i in range(ordre):
            for j in range(ordre):
                if sommet[j] in self.dico_voisins[sommet[i]]:
                    matrice[i][j] = 1
        return matrice
    
    def afficher_matrice_d_adjacence(self):
        matrice = self.matrice_d_adjacence()
        ordre = len(matrice)
        for i in range(ordre):
            affichage=""
            for j in range(ordre):
                affichage+=" "+str(matrice[i][j])+" "
            print(affichage)
                
    
    def __eq__(self,autre_graphe):
        # Renvoie True si les 2 graphes sont identiques False sinon
        # Remarque : 2 graphes sont identiques s'ils ont la même matrice d'adjacence
        pass # A COMPLETER
    

    
#exemple de dictionnaire de voisins:
dico_voisins1 = {"A":["B","C"],"B":["A","D","H"],"C":["A","D"],"D":["B","C","E","F"],"E":["D","G"],"F":["D"],"G":["E"],"H":["B"]}
dico_voisins2 = {"F":["D"],"G":["E"],"B":["D","A","H"],"H":["B"],"E":["G","D"],"C":["D","A"],"A":["C","B"],"D":["F","B","C","E"]}
dico_voisins3 = {"A":["B","C","D"],"B":["A","E"],"C":["A","F"],"D":["A","G"],"E":["B","H"],"F":["C","I"],"G":["D","J"],"H":["E"],"I":["F"],"J":["G"]}
G1 = GrapheNO(dico_voisins1)
G2 = GrapheNO(dico_voisins2)
G3 = GrapheNO(dico_voisins3)


# En utilisant les méthodes définies ci-dessus, répondre aux questions suivanntes :

# Parmi les 3 graphes ci-dessus, y a t-il des graphes identiques ?





# Ci-dessous, on donne une instance  reseau_social de la classe GrapheNO représentant un reseau social.

reseau_social=GrapheNO({})
reseau_social.creer_arete_entre('Antoine','Béatrice')
reseau_social.creer_arete_entre('Antoine','Céline')
reseau_social.creer_arete_entre('Antoine','Denis')
reseau_social.creer_arete_entre('Antoine','Eric')
reseau_social.creer_arete_entre('Béatrice','Francesco')
reseau_social.creer_arete_entre('Béatrice','Grégoire')
reseau_social.creer_arete_entre('Denis','Henri')
reseau_social.creer_arete_entre('Denis','Julia')
reseau_social.creer_arete_entre('Denis','Béatrice')
reseau_social.creer_arete_entre('Julia','Kevin')
reseau_social.creer_arete_entre('Kevin','Quentin')
reseau_social.creer_arete_entre('Eric','Isabelle')
reseau_social.creer_arete_entre('Eric','Matthew')
reseau_social.creer_arete_entre('Matthew','Liam')
reseau_social.creer_arete_entre('Nicolas','Matthew')
reseau_social.creer_arete_entre('Patrick','Matthew')
reseau_social.creer_arete_entre('Quentin','Matthew')
reseau_social.creer_arete_entre('Patrick','Quentin')
reseau_social.creer_arete_entre('Omar','Nicolas')
reseau_social.creer_arete_entre('Liam','Omar')
reseau_social.creer_arete_entre('Céline','Liam')
reseau_social.creer_arete_entre('Ruben','Julia')


# Combien y a t-il de membres dans ce reseau social ?


# Ce reseau est-il connexe ?



# Quel membre a le plus d'amis ?



# Quel est le nombre moyen d'amis ?




# Quel sont les deux membres les plus éloigné l'un de l'autre ?




# Combien de personnes ont plus d'amis que tous leurs amis ?




