class File():
    """
    Implémentation d'une file
    """
    
    def __init__(self):
        """
        Constructeur : Initialisation de l'instance
        """  
        # Initialisation des attributs publiques
        self.contenu = []
 
    
    def est_vide(self):
        return self.contenu == []
        
    def enfile(self, valeur):
        """
        methode pour enfiler la valeur passée en paramètre
        """
        self.contenu.append(valeur)
  
    def defile(self):
        """
        methode qui defile et renvoie la valeur sortie de la file
        Attention : si la file est vide, depile retourne None
        Attention : on ne peut pas faire de "pop(0)" avec une liste vide
        """ 
        #si la pile est vide
        if self.est_vide():
            return None
        else :
            return self.contenu.pop(0)
        
    def contient(self,valeur):
        """
        prédicat qui retour True si la valeur passée en paramètre
        fait partie de la file, False sinon
        """
        trouve = False
        file_tmp = File()
        while not self.est_vide():
            tmp = self.defile()
            if tmp == valeur :
                trouve = True
            file_tmp.enfile(tmp)
        while not file_tmp.est_vide():
            self.enfile(file_tmp.defile())
        return trouve

#######################################################
"""
print("on déclare une file vide")
ficelle=File()
print(ficelle.est_vide())
print("on enfile la valeur 3")
ficelle.enfile(3)
print(ficelle.est_vide())
print("on enfile la valeur 7")
ficelle.enfile(7)
print(ficelle.est_vide())
print("on defile")
print(ficelle.defile())
print(ficelle.est_vide())
print("on defile")
print(ficelle.defile())
print(ficelle.est_vide())
print("on defile")
print(ficelle.defile())
print("et il ne se passe rien puisque la pile est vide")
print(ficelle.est_vide())
"""       
        