class Pile():
    """
    Implémentation d'une pile
    """
    
    def __init__(self):
        """
        Constructeur : Initialisation de l'instance
        """ 
        # Initialisation des attributs publiques
        self.hauteur = 0
        self.sommet = None # None signifie que la pile est vide
        
        # Initialisation du reste de la pile (attribut privé)
        self.__reste = []
    
    def est_vide(self):
        return self.hauteur == 0
        #return self.sommet == None
    
    def empile(self, valeur):
        """
        methode pour empiler la valeur passée en paramètre
        """
        if self.hauteur > 0:
            # Le sommet de la pile passe dans le reste
            self.__reste.append(self.sommet)
        # le nouveau sommet est la valeur qu'on empile
        self.sommet = valeur
        # La hauteur de la pile augmente de 1
        self.hauteur += 1
        
    def depile(self):
        """
        methode qui depile et renvoie la valeur sortie de la pile
        Attention : si la pile est vide, depile retourne None
        Attention : on ne peut pas faire de "pop" avec une liste vide
        """
        
        #si la pile est vide
        if self.hauteur == 0:
            return None  
        else :
            #la longueur de la pile diminue de 1
            self.hauteur-=1
            #on sauvegarde le sommet qui va être dépilé
            top=self.sommet
            # le nouveau sommet est la dernière valeur du reste que l'on pop 
            if self.hauteur>0:
                self.sommet=self.__reste.pop()
            else :
                self.sommet=None
            return top

    def contient(self,valeur):
        """
        prédicat qui retour True si la valeur passée en paramètre
        fait partie de la pile, False sinon
        """
        trouve = False
        pile_tmp = Pile()
        while not self.est_vide():
            tmp = self.depile()
            if tmp == valeur :
                trouve = True
            pile_tmp.empile(tmp)
        while not pile_tmp.est_vide():
            self.empile(pile_tmp.depile())
        return trouve
#######################################################
"""
print("on déclare une pile vide")
face=Pile()
print("on affiche sa hauteur")
print(face.hauteur)
print(face.est_vide())
print("on empile la valeur 3")
face.empile(3)
print("on affiche la hauteur de la pile")
print(face.hauteur)
print(face.est_vide())
print("on affiche le sommet de la pile")
print(face.sommet)
print("on empile la valeur 7")
face.empile(7)
print("on affiche la hauteur de la pile")
print(face.hauteur)
print(face.est_vide())
print("on affiche le sommet de la pile")
print(face.sommet)
print("on depile")
face.depile()
print("on affiche la hauteur de la pile")
print(face.hauteur)
print("on affiche le sommet de la pile")
print(face.sommet)
print("on depile")
face.depile()
print("on affiche la hauteur de la pile")
print(face.hauteur)
print("on affiche le sommet de la pile")
print(face.sommet)
print("on depile")
face.depile()
print("et il ne se passe rien puisque la pile est vide")
print(face.est_vide())
"""        
        